Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/ISOContainerBinPackingProblem.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/ISOContainerBinPackingProblem.cs	(revision 9562)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/ISOContainerBinPackingProblem.cs	(revision 9563)
@@ -49,10 +49,11 @@
   [StorableClass]
   [Creatable("Problems")]
-  public class ISOContainerBinPackingProblem : RegularIdenticalBinPackingProblem<ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem> {
+  public class ISOContainerBinPackingProblem : CuboidIdenticalBinPackingProblem {
+
 
     #region Default Instance
-    private static readonly BPPData DefaultInstance = new BPPData() {  
-      Name = "3D BPP Default Instance", 
-      Description = "The default instance for 3D Bin Packing.",
+    private static readonly RealBPPData DefaultInstance = new RealBPPData() {  
+      Name = "3D BPP with weigthed items Default Instance", 
+      Description = "The default instance for 3D Bin Packing Problem with weighted items.",
       BinMeasures = new int[] {25,25,35},
       ItemMeasures = new int[][] {
@@ -99,5 +100,72 @@
         new int[] {9,11,9}
       },
-      Items = 30
+      Items = 30,
+      ItemWeights = new double[] {
+        12*5*10,
+        10*18*20,
+        9*7*7,
+        21*12*4,
+        8*8*12,
+        3*6*14,
+        20*4*9,
+        5*9*8,
+        7*17*3,
+        13*20*15,
+        9*11*9,
+        10*18*20,
+        9*7*7,
+        21*12*4,
+        8*8*12,
+        3*6*14,
+        20*4*9,
+        5*9*8,
+        7*17*3,
+        13*20*15,
+        9*11*9,
+        10*18*20,
+        9*7*7,
+        21*12*4,
+        8*8*12,
+        3*6*14,
+        20*4*9,
+        5*9*8,
+        7*17*3,
+        13*20*15,
+        9*11*9
+      },
+      ItemMaterials = new int[] {
+        1,
+        0,
+        0,
+        1,
+        0,
+        0,
+        1,
+        1,
+        0,
+        1,
+        1,
+        0,
+        0,
+        1,
+        0,
+        0,
+        1,
+        1,
+        0,
+        1,
+        1,
+        0,
+        0,
+        1,
+        0,
+        0,
+        1,
+        1,
+        0,
+        1,
+        1,
+
+      } 
     };
     #endregion
@@ -111,6 +179,6 @@
       return new ISOContainerBinPackingProblem(this, cloner);
     }
-    public ISOContainerBinPackingProblem() : base(
-      new PackingPlanEvaluationAlgorithm<PackingSequenceEncoding, ThreeDimensionalPacking, CuboidPackingBin, CuboidPackingItem>()) {
+    public ISOContainerBinPackingProblem()
+      : base() {
     }
 
@@ -119,10 +187,9 @@
     #region Helpers
     protected override void InitializeDecoder() {
-      if (SolutionCreator is PackingSequenceRandomCreator) {
-        PackingSolutionDecoder = new ExtremePointPackingSequenceDecoder3D();
-      } else if (SolutionCreator is GroupingVectorRandomCreator) {
-        PackingSolutionDecoder = new ExtremePointGroupingVectorDecoder3D();
-      } else if (SolutionCreator is MultiComponentVectorRandomCreator) {
-        PackingSolutionDecoder = new ExtremePointMultiComponentVectorDecoder3D();
+      Operators.RemoveAll(op => typeof(I2DOperator).IsAssignableFrom(op.GetType()));
+
+      PackingSolutionDecoderParameter.ValidValues.Clear();
+      if (SolutionCreator is MultiComponentVectorRandomCreator) {
+        PackingSolutionDecoderParameter.ValidValues.Add(new ISOContainerMultiComponentVectorDecoder3D());
       } else {
         string error = "The given problem does not support the selected solution-creator.";
@@ -131,8 +198,4 @@
     }
 
-    protected override IPackingPlanEvaluator CreateDefaultEvaluator() {
-      return new PackingRatioCuboidIdenticalBinEvaluator();
-    }
-
     protected override void InitializeProblemData() {
       Load(DefaultInstance);
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/RectangularIdenticalBinPackingProblem.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/RectangularIdenticalBinPackingProblem.cs	(revision 9562)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/RectangularIdenticalBinPackingProblem.cs	(revision 9563)
@@ -108,5 +108,5 @@
     }
     public RectangularIdenticalBinPackingProblem() : base(
-      new PackingPlanEvaluationAlgorithm<PackingSequenceEncoding, TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem>()) {
+      new PackingPlanEvaluationAlgorithm<Permutation, TwoDimensionalPacking, RectangularPackingBin, RectangularPackingItem>()) {
     }
 
@@ -116,10 +116,14 @@
       Operators.RemoveAll(op => typeof(I3DOperator).IsAssignableFrom(op.GetType()));
 
-      if (SolutionCreator is PackingSequenceRandomCreator) {
-        PackingSolutionDecoder = new ExtremePointPackingSequenceDecoder2D();
-      } else if (SolutionCreator is GroupingVectorRandomCreator) {
-        PackingSolutionDecoder = new ExtremePointGroupingVectorDecoder2D();
-      } else if (SolutionCreator is MultiComponentVectorRandomCreator) {
-        PackingSolutionDecoder = new ExtremePointMultiComponentVectorDecoder2D();
+      PackingSolutionDecoderParameter.ValidValues.Clear();
+      if (SolutionCreator is PackingSequenceRandomCreator) {        
+        PackingSolutionDecoderParameter.ValidValues.UnionWith(ApplicationManager.Manager.GetInstances<I2DPSDecoder>());
+        //PackingSolutionDecoder = new ExtremePointPackingSequenceDecoder2D();
+      } else if (SolutionCreator is GroupingVectorRandomCreator) {  
+        PackingSolutionDecoderParameter.ValidValues.UnionWith(ApplicationManager.Manager.GetInstances<I2DGVDecoder>());
+        //PackingSolutionDecoder = new ExtremePointGroupingVectorDecoder2D();
+      } else if (SolutionCreator is MultiComponentVectorRandomCreator) {  
+        PackingSolutionDecoderParameter.ValidValues.UnionWith(ApplicationManager.Manager.GetInstances<I2DMCVDecoder>());
+        //PackingSolutionDecoder = new ExtremePointMultiComponentVectorDecoder2D();
       } else {
         string error = "The given problem does not support the selected solution-creator.";
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/RegularIdenticalBinPackingProblem.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/RegularIdenticalBinPackingProblem.cs	(revision 9562)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Problem/RegularIdenticalBinPackingProblem.cs	(revision 9563)
@@ -56,6 +56,6 @@
       get { return (ValueParameter<B>)Parameters["PackingBinMeasures"]; }
     }
-    public OptionalValueParameter<IPackingSolutionDecoder> PackingSolutionDecoderParameter {
-      get { return (OptionalValueParameter<IPackingSolutionDecoder>)Parameters["PackingSolutionDecoder"]; }
+    public ConstrainedValueParameter<IPackingSolutionDecoder> PackingSolutionDecoderParameter {
+      get { return (ConstrainedValueParameter<IPackingSolutionDecoder>)Parameters["PackingSolutionDecoder"]; }
     }
     #endregion
@@ -85,5 +85,5 @@
       Parameters.Add(new ValueParameter<B>("PackingBinMeasures", "Packing-bin data defining the measures of the used bins.", new B()));
       Parameters.Add(new ValueParameter<IPackingPlanEvaluator>("PackingPlanEvaluator", "The evaluator is used to determine the quality of a solution.", CreateDefaultEvaluator()));
-      Parameters.Add(new OptionalValueParameter<IPackingSolutionDecoder>("PackingSolutionDecoder", "The operator that decodes the representation and creates a packing plan."));
+      Parameters.Add(new ConstrainedValueParameter<IPackingSolutionDecoder>("PackingSolutionDecoder", "The operator that decodes the representation and creates a packing plan."));
       this.Maximization.Value = true;
       InitializeProblemInstance();
@@ -232,5 +232,6 @@
 
     #region Problem instance handling
-    public void Load(BPPData data) { 
+    public virtual void Load(BPPData data) {
+      var realData = data as RealBPPData;
       var binData = new B();
       binData.InitializeFromMeasures (data.BinMeasures);
@@ -241,4 +242,8 @@
         item.InitializeFromMeasures(data.ItemMeasures[j]);
         item.AddTargetBinMeasures(data.BinMeasures);
+        if (realData != null) {
+          item.Weight = realData.ItemWeights[j];
+          item.Material = realData.ItemMaterials[j];
+        }
         itemData.Add(item);
       }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs	(revision 9562)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Shapes/CuboidPackingShape.cs	(revision 9563)
@@ -130,11 +130,14 @@
       //Using "Clustered-Area-Height"-comparison as descr
 
-      int result = this.MultipliedMeasures.CompareTo(other.MultipliedMeasures);
+      int result = (this.Width * this.Depth).CompareTo (other.Width * other.Depth);
+	  
+	  if (result == 0)
+		result = this.MultipliedMeasures.CompareTo(other.MultipliedMeasures);
       //if (result == 0) {
       //  result = this.Depth.CompareTo(other.Depth) + this.Width.CompareTo(other.Width);
       //  if (result == 0) {        
       //    result = this.Width.CompareTo(other.Width);
-          if (result == 0)               
-            result = this.Height.CompareTo(other.Height);
+	  if (result == 0)               
+		result = this.Height.CompareTo(other.Height);
       //  }
       //}
